#include <stdio.h>
#include <iostream>
using namespace std;

class pacijent
{
    public :
    string grupa;
    int potreba;
    int o;
    int a;
    int b;
    int ab;
};

int main()
{
    int abkol, n, o, a, b, ab;
    cin >> n;
    cin >> o >> a >> b >> ab;
    pacijent pacijenti [100];
    for(int i = 0; i < n; i++)
    {
        cin >> pacijenti[i].grupa >> pacijenti[i].potreba;
        if(pacijenti[i].grupa == "o")
        {
            pacijenti[i].o = pacijenti[i].potreba;
            o -= pacijenti[i].potreba;
        }
        if(pacijenti[i].grupa == "ab")
        {
            abkol += pacijenti[i].potreba;
        }
    }
    
    for(int i = 0; i < n; i++)
    {
        if(pacijenti[i].grupa == "a")
        {
            if(pacijenti[i].potreba > a)
            {
                pacijenti[i].a = a;
                pacijenti[i].o = pacijenti[i].potreba - pacijenti[i].a;
                o -= pacijenti[i].potreba - pacijenti[i].a;
                a = 0;
            }
            else
            {
                pacijenti[i].a = pacijenti[i].potreba;
                a -= pacijenti[i].potreba;
            }
            
        }
        if(pacijenti[i].grupa == "b")
        {
            if(pacijenti[i].potreba > b)
            {
                pacijenti[i].b = b;
                pacijenti[i].o = pacijenti[i].potreba - pacijenti[i].b;
                o -= pacijenti[i].potreba - pacijenti[i].b;
                b = 0;
            }
            else
            {
                pacijenti[i].b = pacijenti[i].potreba;
                b -= pacijenti[i].potreba;
            }
            
        }
    }
    if(a + b + o + ab >= abkol)
    {
        for(int i = 0; i < n; i++)
        {
            if(pacijenti[i].grupa == "ab")
            {
                if(pacijenti[i].potreba > ab)
                {
                    pacijenti[i].ab = ab;
                    ab = 0;
                    if(pacijenti[i].potreba - ab > a)
                    {
                        pacijenti[i].a = a;
                        a = 0;
                        if(pacijenti[i].potreba - ab - a > b)
                        {
                            pacijenti[i].b = b;
                            b = 0;
                            pacijenti[i].o = pacijenti[i].potreba - pacijenti[i].a - pacijenti[i].b - pacijenti[i].ab;
                            o -= pacijenti[i].potreba - pacijenti[i].a - pacijenti[i].b - pacijenti[i].ab;
                        }
                    }
                }
            }
        }
        if(o > 0)
        {
            cout << "moguce" << endl;
            for(int i = 0; i < n; i++)
            {
                cout << pacijenti[i].o << ' ' << pacijenti[i].a << ' ' << pacijenti[i].b << ' ' << pacijenti[i].ab << endl;
            }
        }
        else
        {
            cout << "nemoguce";    
        }
    }
    else
    {
        cout << "nemoguce";
    }
}